
#BOSS PREP ------------------------------
#Boss starts upon hitting the corrupted enderman - Tick 1


execute as @s[scores={enderbosstime=20..100}] at @s run tag @s add ultris_boss_isultra
execute as @s[scores={enderbosstime=5..20}] at @s run tp @s ~ ~ ~
execute as @s[scores={enderbosstime=1..8}] at @s run tag @s add enderboss_silent
execute as @s[scores={enderbosstime=200..500}] at @s run tag @s remove enderboss_silent
execute run scoreboard players add @s enderbosstime 0
execute as @s[scores={enderbosstime=0..200}] at @s run data merge entity @s {Health:220f}
execute as @s[scores={enderbosstime=1.. }] at @s run scoreboard players add @s enderbosstime 1
execute as @s[scores={enderbosstime=200}] run execute as @s at @s run tag @s add enderbosstp
execute as @s[scores={enderbosstime=1..3}] run execute as @s at @s run playsound minecraft:entity.wither.break_block hostile @a[distance=..20] ~ ~ ~ 2 .5
execute as @s[scores={enderbosstime=1..3}] run execute as @s at @s run particle minecraft:end_rod ~ ~ ~ .7 2 .7 .2 100 normal
execute as @s[scores={enderbosstime=1..8}] run execute as @s at @s run playsound minecraft:ambient.cave hostile @a[distance=..30] ~ ~ ~ 1 .7



execute if block ~ ~ ~ #1_splatus:ultris/permeable if score @s enderbosstime matches 200..1000 run data merge entity @s {NoAI:0b}
execute unless block ~ ~ ~ #1_splatus:ultris/permeable if score @s enderbosstime matches 200..1000 run data merge entity @s {NoAI:1b}

#music
execute as @s[scores={enderbosstime=150}] run execute as @s at @s run execute as @a[distance=..20] run function 1_splatus:ultris/music/play_sinisteraura
execute as @s[scores={enderbosstime=150..230}] at @s run function 1_splatus:ultris/corrupted_ender/events/spin

execute as @s[scores={enderbosstime=3}] run execute as @s at @s run function 1_splatus:ultris/other/boss_attacks/summon_particles_big
execute if score 1 ultris_clock matches 1 as @s[scores={enderbosstime=4..100}] run execute as @s at @s run function 1_splatus:ultris/other/boss_attacks/summon_particles_less

#-----------------------------------
#BOSS START: Phase 1 Tick 200

#advancement(S)
execute as @s[scores={enderbosstime=200}] run execute as @s at @s run advancement grant @a[distance=..30] only 1_splatus:ultris/ender
execute as @s[scores={enderbosstime=3002..},tag=ultris_boss_isultra] run execute as @s at @s run advancement grant @a[distance=..30] only 1_splatus:ultris/completed_ultra corrupted_enderman
execute as @s[scores={enderbosstime=3002}] run execute as @s at @s run advancement grant @a[distance=..30] only 1_splatus:ultris/enderkill
execute as @s[scores={enderbosstime=3002}] run execute as @s at @s run scoreboard players add @a[distance=..30] kills_ender 1
execute as @s[scores={enderbosstime=3080}] run execute as @s at @s run recipe give @a[distance=..30] 1_splatus:ultris/command
#-----

#teleport

execute as @s[scores={enderbosstime=200..3000}] if score 1 ultris_clock matches 1 if predicate 1_splatus:chance/5_percent run function 1_splatus:ultris/other/boss_attacks/teleport
#execute as @s[scores={enderbosstime=200..3000}] if predicate 1_splatus:chance/10_percent run data modify entity @s NoAI set value 1
#execute as @s[scores={enderbosstime=200..3000}] if predicate 1_splatus:chance/10_percent run data modify entity @s NoAI set value 0

##execute as @s[scores={enderbosstime=300}] run execute as @s at @s run execute at @p[distance=..30] run spreadplayers ~ ~ 1 5 false @e[distance=..20]
##execute as @s[scores={enderbosstime=400}] run execute as @s at @s run execute at @p[distance=..30] run spreadplayers ~ ~ 1 5 false @e[distance=..20]
##execute as @s[scores={enderbosstime=500}] run execute as @s at @s run execute at @p[distance=..30] run spreadplayers ~ ~ 1 5 false @e[distance=..20]

# corrupt orbs
execute if score 1 ultris_clock matches 1 as @s[scores={enderbosstime=200..3000}] if entity @p[distance=..32] if predicate 1_splatus:chance/4_percent positioned ~ ~2 ~ run function 1_splatus:ultris/other/boss_attacks/ender_projecticle



execute as @s[scores={enderbosstime=200..3000}] at @s if score 1 ultris_clock matches 1 if predicate 1_splatus:chance/10_percent run function 1_splatus:ultris/corrupted_ender/speedup


##execute as @s[scores={enderbosstime=600}] run execute as @s at @s run execute at @p[distance=..30] run spreadplayers ~ ~ 1 5 false @e[distance=..20]
##execute as @s[scores={enderbosstime=700}] run execute as @s at @s run execute at @p[distance=..30] run spreadplayers ~ ~ 1 5 false @e[distance=..20]

#Split Starts - Tick 850

#execute as @s[scores={enderbosstime=870}] run execute as @s at @s positioned ~ ~1 ~ run function 1_splatus:ultris/other/boss_attacks/shulker_bullet

#Cycle Repeat - Tick 903
execute as @s[scores={enderbosstime=903..906}] run execute as @s at @s run scoreboard players set @s enderbosstime 203







#--------------------------------
#BOSS: Phase 2 Tick 2000 - Fast TP every 2 seconds

#tp
##xecute as @s[scores={enderbosstime=2040}] run execute as @s at @s run execute at @r[distance=..30] run spreadplayers ~ ~ 1 5 false @e[distance=..20]
##xecute as @s[scores={enderbosstime=2080}] run execute as @s at @s run execute at @r[distance=..30] run spreadplayers ~ ~ 1 5 false @e[distance=..20]
##xecute as @s[scores={enderbosstime=2120}] run execute as @s at @s run execute at @r[distance=..30] run spreadplayers ~ ~ 1 5 false @e[distance=..20]
##xecute as @s[scores={enderbosstime=2160}] run execute as @s at @s run execute at @r[distance=..30] run spreadplayers ~ ~ 1 5 false @e[distance=..20]



execute as @s[scores={enderbosstime=2160}] run execute as @s at @s positioned ~ ~1 ~ run function 1_splatus:ultris/other/boss_attacks/shulker_bullet

#win
execute as @s[scores={enderbosstime=1..2000,enderhealth=..40}] run scoreboard players set @s enderbosstime 4000

#Cycle Repeat - Tick 2164 
execute as @s[scores={enderbosstime=2165}] run execute as @s at @s run scoreboard players set @s enderbosstime 2009








team join noname @s[tag=enderboss]


#--------------------------------
#BOSS: Phase 2 Tick 2000 - Fast TP every 2 seconds

#tp
##xecute as @s[scores={enderbosstime=2040}] run execute as @s at @s run execute at @r[distance=..30] run spreadplayers ~ ~ 1 5 false @s[distance=..20]
##xecute as @s[scores={enderbosstime=2080}] run execute as @s at @s run execute at @r[distance=..30] run spreadplayers ~ ~ 1 5 false @s[distance=..20]
##xecute as @s[scores={enderbosstime=2120}] run execute as @s at @s run execute at @r[distance=..30] run spreadplayers ~ ~ 1 5 false @s[distance=..20]
##xecute as @s[scores={enderbosstime=2160}] run execute as @s at @s run execute at @r[distance=..30] run spreadplayers ~ ~ 1 5 false @s[distance=..20]


#win???
execute as @s[scores={enderbosstime=1..2000,enderhealth=..28}] run scoreboard players set @s enderbosstime 2999

#Cycle Repeat - Tick 2164 
execute as @s[scores={enderbosstime=2165}] run execute as @s at @s run scoreboard players set @s enderbosstime 2009







#---------------------------------------------------------
#BOSS: ALMOST DEFEATED - Final Phase - Tick 4000

execute as @s[scores={enderbosstime=4000..}] run execute as @s at @s run function 1_splatus:ultris/corrupted_ender/events/final_phase





#---------------------------------------------------------
#BOSS: DEFEATED - Phase End - Tick 3000

execute as @s[scores={enderbosstime=3001..3999}] run execute as @s at @s run function 1_splatus:ultris/corrupted_ender/events/death_animation









#LOGS
execute as @s[scores={enderbosstime=5}] run tellraw @a[tag=ultris_log] [{"translate":"[Ultris Debug: Corrupted Enderman boss activated - Tick 1]","color": "gray","italic": true}]
execute as @s[scores={enderbosstime=300}] run tellraw @a[tag=ultris_log] [{"translate":"[Ultris Debug: Corrupted Enderman teleported - Tick 300]","color": "gray","italic": true}]
execute as @s[scores={enderbosstime=500}] run tellraw @a[tag=ultris_log] [{"translate":"[Ultris Debug: Corrupted Enderman teleported - Tick 500]","color": "gray","italic": true}]
execute as @s[scores={enderbosstime=700}] run tellraw @a[tag=ultris_log] [{"translate":"[Ultris Debug: Corrupted Enderman teleported - Tick 700]","color": "gray","italic": true}]

execute as @s[scores={enderbosstime=3001}] run tellraw @a[tag=ultris_log] [{"translate":"[Ultris Debug: Corrupted Enderman death animation - Tick 3001]","color": "gray","italic": true}]
execute as @s[scores={enderbosstime=450}] run tellraw @a[tag=ultris_log] [{"translate":"[Ultris Debug: Corrupted Enderman shulker bullet - Tick 450]","color": "gray","italic": true}]
execute as @s[scores={enderbosstime=870}] run tellraw @a[tag=ultris_log] [{"translate":"[Ultris Debug: Corrupted Enderman shulker bullet - Tick 870]","color": "gray","italic": true}]








#scoreboards


